package com.rnsocial;


import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.ReadableMap;
import com.rnsocial.SocialConfig;
import com.tencent.mm.opensdk.modelbiz.WXLaunchMiniProgram;
import com.tencent.mm.opensdk.openapi.IWXAPI;
import com.tencent.mm.opensdk.openapi.WXAPIFactory;
import com.umeng.socialize.bean.SHARE_MEDIA;

import java.util.Objects;

/**
 * Created by ZYWu on 2017/10/26.
 */

public class ReactSocialModule extends ReactContextBaseJavaModule {

    private final static String REACT_NAME = "ReactSocial";
    public static ReactApplicationContext context ;

    private static String qqName = "com.tencent.mqq";
    private static String wechatName = "com.tencent.mm";
    private static String sinaName = "com.sina.weibo";
    private static String aliName = "com.eg.android.AlipayGphone";



    public ReactSocialModule(ReactApplicationContext reactContext) {
        super(reactContext);
        context = reactContext;
    }

    @Override
    public String getName() {
        return REACT_NAME;
    }

    @ReactMethod
    public void isInstall(final int media, final Callback callback){
        String type = null;
        switch (media) {
            case 4:
                type = qqName;
                break;
            case 1:
                type =wechatName;
                break;
            case 7:
                type =aliName;
                break;
            case 0:
                type =sinaName;

                break;
        }
        SocialConfig.isInstall(type);
        callback.invoke(SocialConfig.isInstall(type));
    }

    @ReactMethod
    public void launchMiniProgram(final ReadableMap params) {

      String appId = SocialConfig.getWechatId(); // 填移动应用(App)的 AppId，非小程序的 AppID
      IWXAPI api = WXAPIFactory.createWXAPI(context, appId);

      WXLaunchMiniProgram.Req req = new WXLaunchMiniProgram.Req();
      req.userName = params.getString("appId"); // "gh_d43f693ca31f"; // 填小程序原始id
      req.path = params.getString("path");                  ////拉起小程序页面的可带参路径，不填默认拉起小程序首页，对于小游戏，可以只传入 query 部分，来实现传参效果，如：传入 "?foo=bar"。
      // 可选打开 开发版，体验版和正式版
      if (null != params.getString("miniprogramType")) {
        req.miniprogramType = Integer.valueOf(params.getString("miniprogramType"));
      }
      api.sendReq(req);
    }

}
